include "s1.inc"
include "Char.inc"
include "mazy.inc"
include "Map.inc"
include "direct.inc"

ext Chars, Ascii
ext Map

dseg
vvram defs WindowWidth*WindowHeight
public vvram
BaseX	defb	0
BaseY	defb	0

public BaseX, BaseY

BackupOffset equ Backup-vvram


zseg
yCount:
    defb 0
xCount:
    defb 0
dotCount:
    defb 0
pVram:
    defw 0


dseg
Backup:
Backup0:
	defs WindowWidth*WindowWidth
Backup1:
	defs WindowWidth*WindowWidth
VramBank:
    defb 0
pBackup: public pBackup
	defw 0


cseg
ClearPage:
    ldx #0
    do
        clr ,x+
        cmpx #$1000
    while ne | wend
rts

ClearAll: public ClearAll
    pshs a,b,x,y
        lda #$07 | sta $fe21
        lda #$b0
        do
            sta $fe00
            bsr ClearPage
            inca
            cmpa #$b4
        while ne | wend
        lda #$bc | sta $fe00
        bsr ClearPage

        ldx #Backup
        ldy #WindowWidth*WindowWidth*2
        do
            clr ,x+
            leay -1,y
        while ne | wend

        lda #$e0 | sta $FE23
        lda #$b2 | sta VramBank
        ldx #Backup1 | stx pBackup
    puls a,b,x,y
rts


Print24b:
    pshs x,y
        lda $fe00 | inca | sta $fe01
        lda #1
        do
            pshs a
                sta $fe21
                ldb #CharHeight
                do
                    lda ,x+
                    sta ,y
                    leay $400,y
                    decb
                while ne | wend
                leay -$400*CharHeight,y
            puls a
            lsla
            cmpa #8
        while ne | wend
    puls x,y
rts


Print1: public Print1
    pshs a,b,x,y
        ldb #PatternSize
        mul
        addd #Chars
        tfr d,x
        lda #$b0 | sta $fe00
        bsr Print24b
        lda #$b2 | sta $fe00
        bsr Print24b
    puls a,b,x,y
rts


Print8b:
    pshs x,y
        lda $fe00 | inca | sta $fe01
        lda #7 |  sta $fe21
        ldb #CharHeight
        do
            lda ,x+
            sta ,y
            leay $400,y
            decb
        while ne | wend
    puls x,y
rts

PrintC: public PrintC
    pshs a,b,x,y
        suba #' '
        ldb #CharHeight
        mul
        addd #Ascii
        tfr d,x
        lda #$b0 | sta $fe00
        bsr Print8b
        lda #$b2 | sta $fe00
        bsr Print8b
    puls a,b,x,y
    leay 1,y
rts


PrintS: public PrintS
    do  
        lda ,x+
    while ne
        bsr PrintC
    wend
rts


dseg
drawn defw 0
drawn_low equ drawn+1
digit defb 0
cseg
PrintNumber:    public PrintNumber
    ldx #10000
    bsr PrintDigit
    ldx #1000
    bsr PrintDigit
PrintNumber3:   public PrintNumber3
    ldx #100
    bsr PrintDigit
    ldx #10
    bsr PrintDigit
    addb #'0'
    exg b,a
        bsr PrintC
    exg b,a
rts

PrintDigit:
    stx drawn
    pshs a
        lda #'0'
        sta digit
    puls a
    do
        inc digit
        subd drawn
    while cc | wend
    dec digit
    addd drawn
    pshs a
        lda digit
        bsr PrintC
    puls a
rts


PrintByte:  public PrintByte
    ldb #100
    bsr PrintDigitB
PrintByte2: public PrintByte2
    ldb #10
    bsr PrintDigitB
    adda #'0'
    bsr PrintC
rts

PrintDigitB:
    stb drawn_low
    ldb #'0'
    do 
        incb
        suba drawn_low
    while cc | wend
    decb
    adda drawn_low
    exg b,a
        bsr PrintC
    exg b,a
rts


Print2x2:   public Print2x2
    pshs y
        bsr Print1
        inca
        leay 1,y
        bsr Print1
        inca
        leay VramWidth-1,y
        bsr Print1
        inca
        leay 1,y
        bsr Print1
        inca
    puls y
    leay 2,y
rts


    dseg
MapByte defb 0
    cseg
MapToVVram: public MapToVVram
    lda BaseY
    ldb #map.step
    mul
    addd #Map
    tfr d,x

    lda BaseX
    asra
    asra
    asra
    leax a,x

    ldb #1
    lda BaseX
    anda #7
    do | while ne
        aslb
        deca
    wend
    stb MapByte

    ldy #vvram
    lda #WindowHeight
    do
        pshs a,x
            lda #WindowWidth
            do
                pshs a
                    lda ,x
                    anda MapByte
                    if ne
                        lda #Char.Wall
                    else
                        lda #Char.Space
                    endif
                    sta ,y+
                    asl MapByte
                    if eq
                        leax 1,x
                        inc MapByte
                    endif
                puls a
                deca
            while ne | wend
        puls a,x
        leax map.step,x
        deca
    while ne | wend
rts


cseg
VVramToVram: public VVramToVram
    pshs a,b,x,y
        lda VramBank
        sta $fe00

        ldx #Vram+XOffset
        stx <pVram
        ldx #VVram
        ldy pBackup
        lda #WindowHeight
        sta <yCount
        do
            lda #WindowWidth
            sta <xCount
            do 
                ldb ,x+
                cmpb ,y
                if ne
                    stb ,y
                    pshs x,y
                        lda #PatternSize
                        mul
                        addd #Chars
                        tfr d,x
                        ldy <pVram
                        bsr Print24b
                    puls x,y
                endif
                leay 1,y
                pshs x
                    ldx <pVram
                    leax 1,x
                    stx <pVram
                puls x
                dec <xCount
            while ne | wend
            pshs x
                ldx <pVram
                leax VramWidth-WindowWidth,x
                stx <pVram
            puls x
            dec <yCount
        while ne | wend
        lda VramBank
        anda #$02
        if eq
            lda #$e0 | sta $FE23
            lda #$b2 | sta VramBank
            ldx #Backup1 | stx pBackup
        else
            lda #$e2 | sta $FE23
            lda #$b0 | sta VramBank
            ldx #Backup0 | stx pBackup
        endif
    puls a,b,x,y
rts



ToAddress:
    lda <Dp.Y
    ldb #24
    mul
    addd #vvram
    tfr d,y
    lda <Dp.X
    leay a,y
rts


Put2x2: public Put2x2
    sta <Dp.C
    lda #2
    sta <Dp.Counter0
    sta <Dp.Counter1

    lda <Dp.X
    suba BaseX
    if cs
        inca
        if eq 
            rts
        endif
        dec <Dp.Counter0
        inc <Dp.C
    endif
    cmpa #WindowWidth
    if cc
        rts
    endif
    cmpa #WindowWidth-1
    if eq
        dec <Dp.Counter0
    endif
    sta <Dp.X

    lda <Dp.Y
    suba BaseY
    if cs
        inca
        if eq 
            rts
        endif
        dec <Dp.Counter1
        inc <Dp.C
        inc <Dp.C
    endif
    cmpa #WindowHeight
    if cc
        rts
    endif
    cmpa #WindowHeight-1
    if eq
        dec <Dp.Counter1
    endif
    sta <Dp.Y

    bsr ToAddress
    lda <Dp.C
    do
        pshs y,a
            ldb <Dp.Counter0
            do
                sta ,y+
                inca
                decb
            while ne | wend
        puls y,a
        leay WindowWidth,y
        adda #2
        dec <Dp.Counter1
    while ne | wend
rts


Put1x1: public Put1x1
    sta <Dp.c

    lda <Dp.x
    suba BaseX
    if cs
        rts
    endif
    cmpa #WindowWidth
    if cc
        rts
    endif
    sta <Dp.x

    lda <Dp.y
    suba BaseY
    if cs
        rts
    endif
    cmpa #WindowHeight
    if cc
        rts
    endif
    sta <Dp.y

    bsr ToAddress
    lda <Dp.c
    sta ,y
rts
