include "char.inc"
include "direct.inc"

count equ 4

; offsets
xPos equ 0
yPos equ 1
status equ 2
unitSize equ 3

; statuses
status.none equ 0
status.floor equ 1
status.held equ 2
status.flying equ 3

    dseg
knives defs unitSize * count
Kn.Invent defb 0
blink defb 0
    public  knives, Kn.Invent

    extrn ToMapSize, Tst1x1
    extrn Put1x1, Print.Kn.Invent
    extrn man.x, man.y
    extrn goal.x, goal.y
    extrn Sound_Get, Sound_Hit

    cseg
directions:
    defb -1,0,1,0,0,-1,0,1

    dseg
xDiff defb 0
yDiff defb 0
xDis defb 0
yDis defb 0
    cseg
DirectionToGoal:
    lda goal.x
    suba xPos,x
    sta xDiff
    if mi
        nega
    endif
    sta xDis
    lda goal.y
    suba yPos,x
    sta yDiff
    if mi
        nega
    endif
    sta yDis
    cmpa xDis
    if cs
        tst xDiff
        if pl
            lda #1 shl 2
        else
            clra
        endif
    else
        tst yDiff
        if pl 
            lda #3 shl 2
        else
            lda #2 shl 2
        endif
    endif
rts


Kn.Init:    public Kn.Init
    lda ,x+
    sta <Dp.Counter0
    
    ldy #knives
    lda #count
    sta <Dp.Counter1
    do
        lda ,x+ ; xPos
        jsr ToMapSize
        sta xPos,y
        lda ,x+ ; yPos
        jsr ToMapSize
        sta yPos,y
        exg x,y
            bsr DirectionToGoal
        exg x,y            
        ora #status.floor
        sta status,y
        leay unitSize,y
        dec <Dp.Counter1
        dec <Dp.Counter0
    while ne | wend
    tst <Dp.Counter1
    do | while ne
        clr status,y    ; status.none
        leay unitSize,y
        dec <Dp.Counter1
    wend
    clr Kn.Invent
rts


Kn.Start: public Kn.Start
; in
;   Dp.x
;   Dp.y
;   a: direction
    sta <Dp.Counter0
    ldx #knives
    ldb #count
    stb <Dp.Counter1
    do
        lda status,x
        anda #3
        cmpa #status.held
        if eq
            lda <Dp.x
            sta xPos,x
            lda <Dp.y
            sta yPos,x
            lda <Dp.Counter0
            asla
            asla
            ora #status.flying
            sta status,x
            dec Kn.Invent
            jsr Sound_Get
            jsr Print.Kn.Invent
            rts
        endif
        leax unitSize,x
        dec <Dp.Counter1
    while ne | wend
rts


Kn.Move: public Kn.Move
    ldx #knives
    ldb #count
    do
        pshs b
            lda status,x
            anda #3
            beq Move.Next    ; status.none
            deca
            if eq
                ; status.floor
                lda xPos,x
                suba man.x
                if ne
                    deca
                    bne Move.Next
                endif
                lda yPos,x
                suba man.y
                if ne
                    deca
                    bne Move.Next
                endif
                lda status,x
                anda #$fc
                ora #status.held
                sta status,x
                inc Kn.Invent
                jsr Sound_Get
                jsr Print.Kn.Invent
                bra Move.Next
            endif
            deca
            beq Move.Next ; status.held
            deca
            if eq
                ; status.flying
                lda status,x
                anda #$0c
                lsra
                ldy #directions
                leay a,y
                lda xPos,x
                adda ,y
                sta <Dp.x
                lda yPos,x
                adda 1,y
                sta <Dp.y
                jsr Tst1x1
                if eq
                    lda <Dp.x
                    sta xPos,x
                    lda <Dp.y
                    sta yPos,x
                    bsr TestHit
                    bra Move.Next
                endif
                bsr DirectionToGoal
                ora #status.floor
                sta status,x
            endif
            Move.Next:
            leax unitSize,x
        puls b
        decb
    while ne | wend
rts

extrn  Mon.TestHit.Kn, Sound_Hit, Snd.Address
TestHit:
    jsr Mon.TestHit.Kn
    if ne
        ldd #Sound_Hit
        std Snd.Address
        bsr DirectionToGoal
        ora #status.floor
        sta status,x
    endif   
rts


Kn.Draw: public Kn.Draw
    inc blink
    ldx #knives
    ldb #count
    do
        pshs b
            lda status,x
            anda #3
            beq Draw.Next   ;   none
            deca
            if eq
                ; floor
                lda blink
                bita #1
                beq kd1
                bra Draw.Next
            endif
            deca
            beq Draw.Next;   held
            kd1:
                lda xPos,x
                sta <Dp.x
                lda yPos,x
                sta <Dp.y
                lda status,x
                asra
                asra
                anda #3
                adda #Char.Kn.Left
                jsr Put1x1
            Draw.Next:
            leax unitSize,x
        puls b
        decb
    while ne | wend
rts


