include "KeyBits.inc"
include "mazy.inc"
include "char.inc"
include "direct.inc"

dseg
man.x defb 0 | public man.x
man.y defb 0 | public man.y
man.status.die defb 0 | public man.status.die
prevDir defw 0
seq.ptr defw 0
seq.index defb 0
default defb 0
chr defb 0
lastButton defb 0

cseg

; direction structure
Dir.key equ 0
Dir.x equ Dir.key+1
Dir.y equ Dir.x+1
Dir.seq equ Dir.y+1
Dir.stop equ Dir.seq+4
Dir.knife.dir equ Dir.stop+1
Dir.knife.x equ Dir.knife.dir+1
Dir.knife.y equ Dir.knife.x+1
Dir.size equ Dir.knife.y+1
Dir.count equ 4

Directions: 
    ; left direction
    defb Keys_Left
    defb -1,0
    defb Char.Man.Left.1, Char.Man.Left.0, Char.Man.Left.1, Char.Man.Left.2
    defb Char.Man.Stop.Left
    defb 0
    defb 0,0
    ; right direction
    defb Keys_Right
    defb 1,0
    defb Char.Man.Right.1, Char.Man.Right.0, Char.Man.Right.1, Char.Man.Right.2
    defb Char.Man.Stop.Right
    defb 1
    defb 1,0
    ; up direction
    defb Keys_Up
    defb 0,-1
    defb Char.Man.Up.1, Char.Man.Up.0, Char.Man.Up.1, Char.Man.Up.2
    defb Char.Man.Stop.Up
    defb 2
    defb 0,0
    ; down direction
    defb Keys_Down
    defb 0,1
    defb Char.Man.Down.1, Char.Man.Down.0, Char.Man.Down.1, Char.Man.Down.2
    defb Char.Man.Stop.Down
    defb 3
    defb 0,1
Die.Seq:
    defb Char.Man.Stop.Left, Char.Man.Stop.Down, Char.Man.Die.2, Char.Man.Die.3

ext ScanKeys
ext ToMapSize
ext map.width, map.height, BaseX, BaseY, Tst2x2, Put2x2, Stage.Clear
ext Kn.Invent, Kn.Start
ext goal.x,goal.y

cseg

Man.Init:    public Man.Init
    lda ,x+
    jsr ToMapSize
    sta man.x
    lda ,x+
    jsr ToMapSize
    sta man.y
    ldy #directions + Dir.size ; right direction
    sty prevDir
    lda #Char.Man.Stop.Right
    sta chr
    clr seq.index
    clr man.status.die

UpdateBasePosition:
    lda map.width
    suba #WindowWidth
    sta <Dp.Counter0
    lda map.height
    suba #WindowHeight
    sta <Dp.Counter1
    
    lda man.x
    suba #WindowWidth/2
    if cs
        clra
    endif
    cmpa <Dp.Counter0
    if cc
        lda <Dp.Counter0
    endif
    sta baseX

    lda man.y
    suba #WindowHeight/2
    if cs
        clra
    endif
    cmpa <Dp.Counter1
    if cc
        lda <Dp.Counter1
    endif
    sta baseY
rts

dseg
key defb 0
cseg
Man.Move:    public Man.Move
    lda man.status.die
    if ne
        rts
    endif

    jsr ScanKeys
    sta key
    ldx #directions
    ldb #Dir.count
    stb <Dp.Counter0
    do
        lda key
        bita Dir.key,x
        if ne
            lda man.x | adda Dir.x,x | sta <Dp.x
            lda man.y | adda Dir.y,x | sta <Dp.y
            jsr Tst2x2
            if eq 
                stx prevDir
                bra CanMove
            endif
        endif
        leax Dir.size,x
        dec <Dp.Counter0
    while ne | wend

    lda key
    anda #Keys_Dir
    if ne
        ldx prevDir
        lda man.x | adda Dir.x,x | sta <Dp.x
        lda man.y | adda Dir.y,x | sta <Dp.y
        jsr Tst2x2
        if eq
            CanMove:
            lda <Dp.x | sta man.x
            lda <Dp.y | sta man.y

            lda seq.index | inca | anda #3 | sta seq.index
            adda #Dir.seq
            lda a,x
            sta chr
            jsr UpdateBasePosition

            ldd goal.x
            cmpd man.x
            if eq
                inc Stage.Clear
            endif
            bra TestButton
        endif
    endif
    ldx prevDir
    lda Dir.Stop,x
    sta chr
    lda #-1
    sta seq.index
TestButton:
    lda key
    bita #Keys_Button0
    if eq
        clr lastButton
        rts
    endif
    tst lastButton
    if ne
        rts
    endif
    inc lastButton
    tst Kn.Invent
    if eq
        rts
    endif
    lda man.x
    adda Dir.knife.x,x
    sta <Dp.x
    lda man.y
    adda Dir.knife.y,x
    sta <Dp.y
    lda Dir.knife.dir,x
    jsr Kn.Start
rts


Man.Draw: public Man.Draw
    lda man.x
    sta <Dp.X
    lda man.y
    sta <Dp.Y
    lda chr
    jsr Put2x2
rts


extrn VVramToVram, Sound_Loose
Man.Die:    public Man.Die
    clra
    ldb #10
    do
        pshs a,b
            ldx #Die.Seq
            anda #3
            leax a,x
            ldd man.x
            std <Dp.x
            lda ,x
            jsr Put2x2
            jsr VVramToVram
            jsr Sound_Loose
        puls a,b
        inca
        decb
    while ne | wend
rts
