include 'map.inc'
include "char.inc"
include "direct.inc"

dseg
stage		defb	0
public stage
map.width	defb	0
map.height	defb	0
public map.width,map.height
Stage_width		defb	0
Stage_height	defb	0
goal.x defb 0
goal.y defb 0
public goal.x,goal.y
Stage.Time defw 0 | public Stage.Time
blink defb 0
Stage.Clear defb 0 | public Stage.Clear
Stage_byte defb 0
Stage_bitCount defb 0
map.mask defb 0
map.bits defb 0
map	defs MapSize
public map

cseg

ext	Stages, Stage_Count, TimeRate
ext Man.Init
ext Kn.Init
ext Mon.Init
ext Put2x2

ToMapSize: public ToMapSize
    sta <Dp.c
    asla
    adda <Dp.c
    inca
rts

RotBit:
	asl map.mask
	if eq
        lda map.bits
		sta ,y+
        inc map.mask
        clr map.bits
	endif
rts
RotBit2:
	asl map.mask
	if eq
        lda map.bits
		sta ,y
		sta map.step,y
        leay 1,y
        inc map.mask
        clr map.bits
	endif
rts


InitMap: public	InitMap
    ldx #map
    ldd #MapMaxHeight*map.step
    do
        clr ,x+
        subd #1
    while ne | wend

    lda #10
    sta TimeRate
    lda stage
    do
        suba #low Stage_Count
    while cc
        dec TimeRate
    wend
    lda TimeRate
    cmpa #2
    if cs
        lda #2
        sta TimeRate
    endif

    ldb stage
    andb #$0f
    aslb
    clra
    addd #Stages
    tfr d,x
    ldx 0,x

    lda ,x+
    sta Stage_width
    bsr ToMapSize
    sta map.width
    lda ,x+
    sta Stage_height
    bsr ToMapSize
    sta map.height

    ldy #map
    ldb map.width
    lda #1
    sta map.mask
    clr map.bits
    pshs y
        do
            lda map.bits
            ora map.mask
            sta map.bits
            bsr RotBit
            decb
        while ne | wend
        lda map.bits
        sta 0,y
    puls y
    leay map.step,y
    
    lda ,x+
    sta Stage_byte
    lda #8
    sta Stage_bitCount
    lda Stage_height
    do
        pshs a
            pshs y
                lda #1
                sta map.mask
                sta map.bits
                bsr RotBit2
                lda Stage_width
                do
                    pshs a
                        bsr RotBit2
                        bsr RotBit2
                        lda Stage_byte
                        anda #1
                        if ne
                            lda map.bits
                            ora map.mask
                            sta map.bits
                        endif
                        bsr RotBit2
                        asr Stage_byte
                        dec Stage_bitCount
                        if eq
                            lda ,x+
                            sta Stage_byte
                            lda #8
                            sta Stage_bitCount
                        endif
                    puls a
                    deca
                while ne | wend
                lda map.bits
                sta ,y
                sta map.step,y
            puls y
            leay map.step*2,y
            pshs y
                lda #1
                sta map.mask
                sta map.bits
                bsr RotBit
                lda Stage_width
                do
                    pshs a
                        lda Stage_byte
                        anda #1
                        if ne
                            lda map.bits
                            ora map.mask
                            sta map.bits
                            bsr RotBit
                            lda map.bits
                            ora map.mask
                            sta map.bits
                            bsr RotBit
                        else
                            bsr RotBit
                            bsr RotBit
                        endif
                        lda map.bits
                        ora map.mask
                        sta map.bits
                        bsr RotBit
                        asr Stage_byte
                        dec Stage_bitCount
                        if eq
                            lda ,x+
                            sta Stage_byte
                            lda #8
                            sta Stage_bitCount
                        endif
                    puls a
                    deca
                while ne | wend
                lda map.bits
                sta ,y
            puls y
            leay map.step,y
        puls a
        deca
    while ne | wend

    lda Stage_bitCount
    cmpa #8
    if eq
        leax -1,x
    endif

    jsr Man.Init
   
    lda ,x+ | bsr ToMapSize | sta goal.x
    lda ,x+ bsr ToMapSize | sta goal.y

    jsr Kn.Init
    jsr Mon.Init
    ; time
    ldd ,x++ | std Stage.Time
rts


MapAddress:
    lda <Dp.Y
    ldb #map.step
    mul
    addd #map
    tfr d,x
    lda <Dp.X
    lsra
    lsra
    lsra
    leax a,x
rts


Tst2x2:  public Tst2x2
    pshs x
        bsr MapAddress

        ldd #3
        std <Dp.Word0
        lda <Dp.X
        anda #7
        do | while ne
            asl <Dp.Word0+1 | rol <Dp.Word0
            deca
        wend

        ldb #2
        do  
            lda ,x
            bita <Dp.Word0+1
            bne Tst2x2_Exit
            lda 1,x
            bita <Dp.Word0
            bne Tst2x2_Exit
            leax map.step,x
            decb
        while ne | wend
    Tst2x2_Exit:
    puls x
rts


Tst1x1: 	public Tst1x1
    pshs x
        bsr MapAddress

        ldb #1
        lda <Dp.X
        anda #7
        do | while ne
            aslb
            deca
        wend
        andb ,x
    puls x
rts


Goal.Draw: public Goal.Draw
    inc blink
    lda blink
    anda #1
    if ne
        ldd goal.x
        std <Dp.x
        lda #Char.Goal
        jsr Put2x2
    endif
rts