include "mazy.inc"
include "KeyBits.inc"
include "direct.inc"

ext Init, Fin, ScanKeys, TimerCount, PrevKey, WaitTimer
ext MapToVVram, VVramToVram, InitColors
ext InitMap, BaseX, BaseY
ext stage, Stage.Clear, Stage.Time
ext Man.Move, Man.Draw, Man.Die, Man.status.die
ext Kn.Draw, Kn.Move, Kn.Invent
ext Mon.Draw, Mon.Move
ext Goal.Draw
ext PrintStatus, Print.Over, TitleScreen, PrintTime, PrintTimeup
ext Sound_Get, Sound_Loose, Sound_Start, Sound_GameOver, Sound_Clear
ext StartBGM, StopBGM

dseg
Score	defw 0	| public Score
Score.Hi equ Score
Score.Lo equ Score+1
HiScore defw 0 | public HiScore
HiScore.Hi equ HiScore
HiScore.Lo equ HiScore+1
Man.Count defb 0 | public Man.Count 
Snd.Address defw 0 | public Snd.Address
Clock defb 0
TimeRate defb 0 | public TimeRate

ext stage

cseg
entry: public entry
    jsr Init
    clr PrevKey

    ldd #0
    std Score
    std HiScore
    std Stage.Time
    std Snd.Address
    lda #3
    sta Man.Count
    clr Kn.Invent
    clr stage
    jsr PrintStatus
    Title:
    jsr TitleScreen
    do
        ;jsr ScanStop
        ;beq Exit
        jsr ScanKeys
        sta <Dp.C
        bita #Keys_Button0 or Keys_Button1
    while eq | wend
    StartGame:
    ldd #0
    std Score
    lda #3
    sta Man.Count
    lda <Dp.C
    bita #Keys_Button1
    if eq
        clr stage
    endif
           ; inc stage | inc stage  | inc stage
    StartStage:
    clr man.status.die
    clr Clock
    clr BaseX
    clr BaseY
    clr Stage.Clear
    jsr InitMap
    jsr MapToVVram
    jsr Man.Draw
    jsr Mon.Draw
    jsr Kn.Draw
    jsr PrintStatus
    jsr VVramToVram
    jsr Sound_Start
    jsr StartBGM

    jsr ScanKeys
    clr PrevKey
    
    loop:
        jsr Kn.Move
        jsr Man.Move
        jsr Mon.Move
        jsr Kn.Move

        jsr MapToVVram
        jsr Man.Draw
        jsr Mon.Draw
        jsr Goal.Draw
        jsr Kn.Draw
        jsr VVramToVram
        bsr Sound
        lda #8 | jsr WaitTimer

        inc clock
        lda clock
        cmpa TimeRate
        if cc
            clr clock
            ldd Stage.Time
            subd #1
            std Stage.Time
            jsr PrintTime
            ldx Stage.Time
            if eq
                jsr StopBGM
                jsr PrintTimeup
                ldb #15
                do
                    pshs b
                        jsr Sound_Loose
                        ldd #3000
                        do 
                            subd #1
                        while ne | wend
                    puls b
                    decb
                while ne | wend
                bra Die
            endif
        endif

        tst man.status.die
        if ne
            jsr StopBGM
            jsr Man.Die
            Die:
            dec Man.Count
            beq GameOver
            bra StartStage
        endif
        tst Stage.Clear
        if ne
            jsr StopBGM
            jsr Man.Draw
            jsr VVramToVram
            jsr Sound_Clear
            ldx Stage.Time
            do | while ne
                ldd #1
                jsr AddScore
                jsr PrintTime
                jsr Sound_Get
                ldd #1000
                do 
                    subd #1
                while ne | wend
                ldd Stage.Time
                subd #1
                std Stage.Time
            wend
            inc stage
            bra StartStage
        endif
        ;jsr ScanStop
        ;beq Exit
        jsr ScanKeys
    bra loop
    GameOver:
        jsr Print.Over
        jsr Sound_GameOver
        bra Title
Exit:
rts


Sound:
    ldx Snd.Address
    if ne
        jsr ,x
        ldx #0
        stx Snd.Address
    endif
rts


extrn PrintScore
AddScore: public AddScore
    addd Score
    std Score
    cmpd HiScore
    if cc 
        std HiScore
    endif
    jsr PrintScore
rts