include "char.inc"
include "direct.inc"

count equ 8

;offsets
xPos equ 0
yPos equ 1
type equ 2
status equ 3
clock equ 4
unitSize equ 5

status.none equ 0
status.live equ 1
status.die equ 2
type.horizontal equ 0
type.vertical equ 1
type.chase equ 2

dseg
monsters defs unitSize * count
public monsters

extrn ToMapSize, Tst2x2
extrn man.x, man.y, man.status.die
extrn Put2x2

cseg

Mon.Init: public Mon.Init
    lda ,x+
    sta <Dp.Counter0

    ldy #monsters
    lda #count
    sta <Dp.Counter1
    do
        lda ,x+
        jsr ToMapSize
        sta xPos,y
        lda ,x+
        tfr a,b
        anda #$3f
        jsr ToMapSize
        sta yPos,y
        lsrb
        lsrb
        lsrb
        lsrb
        lsrb
        lsrb
        stb type,y
        lda #status.live
        sta status,y
        leay unitSize,y
        dec <Dp.Counter1
        dec <Dp.Counter0
    while ne | wend
    tst <Dp.Counter1
    do | while ne
        clr status,y    ; status.none
        leay unitSize,y
        dec <Dp.Counter1
    wend
rts


Mon.Move:   public Mon.Move
    ldx #monsters
    ldb #count
    do  
        pshs b
            inc clock,x
            lda status,x
            beq Move.Next
            deca
            if eq
                ; status.live
                bsr TestHit.Man
                lda type,x
                if eq
                    ; type.horizontal
                    lda xPos,x
                    cmpa man.x
                    beq Move.Next
                    if cs
                        inca
                    else
                        deca
                    endif
                    sta <Dp.x
                    lda yPos,x
                    sta <Dp.y
                    bra TryToMove
                endif
                deca
                if eq
                    ; type.vertical
                    lda yPos,x
                    cmpa man.y
                    beq Move.Next
                    if cs
                        inca
                    else
                        deca
                    endif
                    sta <Dp.y
                    lda xPos,x
                    sta <Dp.x
                    TryToMove:
                    bsr TestMove
                    bne Move.Next
                    CanMove:
                    lda <Dp.x
                    sta xPos,x
                    lda <Dp.y
                    sta yPos,x
                    bsr TestHit.Man
                    bra Move.Next
                endif
                deca
                if eq
                    ; type.chaser
                    lda clock,x
                    bita #1
                    beq Move.Next
                    
                    lda xPos,x
                    sta <Dp.x
                    lda yPos,x
                    sta <Dp.y
                    lda man.x
                    cmpa <Dp.x
                    if ne
                        if cs
                            dec <Dp.x
                        else
                            inc <Dp.x
                        endif
                        bsr TestMove
                        beq CanMove
                        lda xPos,x
                        sta <Dp.x
                    endif
                    lda man.y
                    cmpa <Dp.y
                    beq Move.Next
                    if cs
                        dec <Dp.y
                    else
                        inc <Dp.y
                    endif
                    bsr TestMove
                    beq CanMove
                    bra Move.Next
                endif
            endif
            deca
            if eq
                ; status.die
                lda clock,x
                cmpa #4
                if eq
                    clr status,x ; status.none
                endif
            endif
            Move.Next:
            leax unitSize,x
        puls b
        decb
    while ne | wend
rts

TestMove:   public TestMove
    stx TestMove_0+2
    jsr Tst2x2
    if eq
        ldy #monsters
        lda #count
        sta <Dp.Counter0
        do
            tfr y,d
TestMove_0: cmpd #0
            if ne
                lda status,y
                deca
                if eq
                    ; status.live
                    lda <Dp.x
                    suba xPos,y
                    inca
                    cmpa #3
                    if cs
                        lda <Dp.y
                        suba yPos,y
                        inca
                        cmpa #3
                        if cs
                            lda #1;  z := 0
                            rts
                        endif
                    endif
                endif
            endif
            leay unitSize,y
            dec <Dp.Counter0
        while ne | wend
        clra ; z := 1
    endif
rts

TestHit.Man:
    lda man.x
    suba xPos,x
    inca
    cmpa #3
    if cs
        lda man.y
        suba yPos,x
        inca
        cmpa #3
        if cs
            inc Man.Status.Die
        endif
    endif
rts


Mon.Draw:   public Mon.Draw
    ldx #monsters
    ldb #count
    do  
        pshs b
            lda status,x
            beq DrawNext
            deca
            if eq
                ; status.live
                lda type,x
                cmpa #type.chase
                if eq
                    lda #Char.Chaser
                    bra put
                endif
                lda #Char.Disturber
                bra put
            endif
            deca
            if eq
                ; status.die
                lda #Char.Bang
                put:
                pshs a
                    lda xPos,x
                    sta <DP.x
                    lda yPos,x
                    sta <Dp.y
                puls a
                jsr Put2x2
            endif
            DrawNext:
            leax unitSize,x
        puls b
        decb
    while ne | wend
rts


ext AddScore
Mon.TestHit.Kn: public Mon.TestHit.Kn
    ldy #monsters
    ldb #count
    clr <Dp.Counter1
    do  
        pshs b
            lda status,y
            deca
            if eq
                lda <Dp.x
                suba xPos,y
                beq hit_x
                deca
                if eq
                    hit_x:
                    lda <Dp.y
                    suba yPos,y
                    beq hit_y
                    deca
                    if eq
                        hit_y:
                        lda #status.die
                        sta status,y
                        clr clock,y
                        inc <Dp.Counter1
                        lda type,y
                        cmpa #type.chase
                        if eq
                            ldd #30 ; 300 Pts.
                        else
                            ldd #10 ; 
                        endif
                        pshs x,y
                            jsr AddScore
                        puls x,y
                    endif
                endif
            endif
            leay unitSize,y
        puls b
        decb
    while ne | wend
    lda <Dp.Counter1
rts