include "s1.inc"
include "KeyBits.inc"
include "Direct.inc"

ext InitSound, SoundHandler

dseg
TimerCount: defb 0 public TimerCount
Division: public Division
    defb 0 
PrevKey: public PrevKey
    defb 0

cseg
Palette:
    defb 0,1+8,2+8,3+8,4+8,5+8,6+8,7+8
Init: public  Init
    lda #$e0 | sta $FE23
    clr $FE24
    clr $FFD0
    clr $FFE0
    clr PrevKey
    lda #$80 | sta $FFD4
    
    ldx #Palette
    ldy #$FE28
    ldb #8
    do
        lda ,x+ | sta ,y+
        decb
    while ne | wend

    lda #high Direct
    tfr a,dp

    clr TimerCount
    clr Division
    jsr InitSound

    orcc #$60
        ldd $eeef
        std Handler_end+1
        ldd #Handler
        std $eeef
    andcc #not $60

rts


KeyTable:
    defb $80,Keys_Button0 
    defb $81,Keys_Up
    defb $83,Keys_Left
    defb $84,Keys_Down
    defb $85,Keys_Right
    defb $87,Keys_Button1
    defb $8d,Keys_Up
    defb $b7,Keys_Left
    defb $be,Keys_Right
    defb $cd,Keys_Down
    defb 0

ScanKeys: public ScanKeys
    pshs b,x
        ldb $FFE0
        bitb #$80
        if ne
            ldx #KeyTable
            do
                lda ,x
            while ne
                cmpb ,x
                if eq
                    lda 1,x
                    sta PrevKey
                    bra ScanKeys_exit
                endif
                leax 2,x
            wend
            clra
            sta PrevKey
        else
            lda PrevKey
        endif
ScanKeys_exit:
    puls b,x
rts


Handler: public Handler
    pshs a
        lda $FFCA
        anda #$40
        if ne
            lda Division
            if eq
                                    _deb: public _deb
                inc TimerCount
                jsr SoundHandler
                lda #8
            else
                deca  
            endif
            sta Division
        endif
    puls a
Handler_end:
jmp $e131


dseg
WaitTimer_param:
    defb 0
cseg
WaitTimer: public WaitTimer
    sta WaitTimer_param
        do
            lda TimerCount
            cmpa WaitTimer_param
        while cs | wend
    lda WaitTimer_param
    orcc #$50
        clr TimerCount
    andcc #not $50
rts
