include "mazy.inc"
include "char.inc"

ext Score, HiScore, Stage, Stage.Time, Kn.Invent, Man.Count
ext ClearAll, PrintS, PrintNumber, PrintNumber3, PrintByte, PrintByte2, Print2x2, Print1, PrintC

    cseg

PrintScore: public PrintScore
    ldd Score
    ldy #Vram + status.x + VramWidth * 1
    jsr PrintNumber
    lda #'0'
    jsr PrintC

    ldd HiScore
    ldy #Vram + status.x + VramWidth * 5
    jsr PrintNumber
    lda #'0'
    jsr PrintC
rts


PrintTime: public PrintTime
    ldd Stage.Time
    ldy #Vram + status.x + VramWidth*11 + 3
    jsr PrintNumber3
rts


Print.Kn.Invent:    public Print.Kn.Invent
    ldy #Vram + status.x + VramWidth*(WindowHeight - 4)
    lda #Char.Kn.Left
    ldb Kn.Invent
    do | while ne
        jsr Print1
        leay 1,y
        decb
    wend
    lda #Char.Space
    ldb #4
    subb Kn.Invent
    do | while ne
        jsr Print1
        leay 1,y
        decb
    wend
rts


Print.Men:
    ldy #Vram + status.x + VramWidth*(WindowHeight - 2)
    ldb Man.Count
    if ne
        do
            decb
        while ne
            lda #Char.Man.Remain
            jsr Print2x2
        wend
    endif
    
    ; ldb #3
    ; subb Man.Count
    ; lda #Char.Space
    ; do
    ;     pshs y
    ;         jsr Print1
    ;         leay 1,y
    ;         jsr Print1
    ;         leay VramWidth-1,y
    ;         jsr Print1
    ;         leay 1,y
    ;         jsr Print1
    ;     puls y
    ;     leay 2,y
    ;     decb
    ; while ne | wend
rts


Str_Score: defb 'SCORE',0
Str_High: defb 'HIGH',0
Str_Stage: defb 'STAGE',0
Str_Time: defb 'TIME',0

PrintStatus: public PrintStatus
    jsr ClearAll

    ldy #Vram + status.x + VramWidth * 0
    ldx #Str_Score
    jsr PrintS
    ldy #Vram + status.x + VramWidth * 3
    ldx #Str_High
    jsr PrintS
    ldy #Vram + status.x + VramWidth * 4
    ldx #Str_Score
    jsr PrintS

    ldy #Vram + status.x + VramWidth * 7
    ldx #Str_Stage
    jsr PrintS

    ldy #Vram + status.x + VramWidth *10
    ldx #Str_Time
    jsr PrintS

    ldy #Vram + status.x + VramWidth * 8 + 4
    lda Stage
    inca
    jsr PrintByte2

    jsr PrintScore
    jsr PrintTime
    jsr Print.Kn.Invent
    jsr Print.Men
rts


WhiteBox:
    ldy #Vram + XOffset + (WindowWidth - 9)/2 + VramWidth * (WindowHeight/2 - 1)
    ldb #3
    do 
        pshs b
            ldb #9
            lda #Char.Space
            do 
                jsr Print1
                leay 1,y
                decb
            while ne | wend
            leay VramWidth - 9,y
        puls b
        decb
    while ne | wend
rts


Str.Over:   defb 'GAME OVER',0
Print.Over: public Print.Over
    jsr WhiteBox    
    ldy #Vram + XOffset + (WindowWidth - 9)/2 + VramWidth * (WindowHeight / 2)
    ldx #Str.Over
jmp PrintS

Str.Timeup:   defb 'TIME UP',0
PrintTimeup: public PrintTimeup
    jsr WhiteBox    
    ldy #Vram + XOffset + (WindowWidth - 7)/2 + VramWidth * (WindowHeight / 2)
    ldx #Str.Timeup
jmp PrintS


Str.Chars: defb '--- CHARACTERS ---',0
Str.Man: defb 'MAN',0
Str.Chaser: defb 'CHASER',0
Str.Disturber: defb 'DISTURBER',0
Str.Exit: defb 'EXIT',0
Str.Push: defb 'PUSH SPACE KEY',0

TitleScreen: public TitleScreen
    jsr PrintStatus

    ldy #Vram + XOffset + 8 + VramWidth*1
    lda #Char.Title
    ldb #4
    do
        jsr Print2x2
        decb
    while ne | wend

    ldy #Vram + XOffset + 6 + VramWidth*7
    lda #Char.Man.Remain
    jsr Print2x2

    ldy #Vram + XOffset + 6 + VramWidth*10
    lda #Char.Chaser
    jsr Print2x2

    ldy #Vram + XOffset + 6 + VramWidth*13
    lda #Char.Disturber
    jsr Print2x2

    ldy #Vram + XOffset + 6 + VramWidth*16
    lda #Char.Goal
    jsr Print2x2

    ldy #VRAM + XOffset + 4 + VramWidth*4
    ldx #Str.Chars
    jsr PrintS

    ldy # VRAM + XOffset + 10 + VramWidth*8
    ldx #Str.Man
    jsr PrintS

    ldy # VRAM + XOffset + 10 + VramWidth*11
    ldx #Str.Chaser
    jsr PrintS

    ldy # VRAM + XOffset + 10 + VramWidth*14
    ldx #Str.Disturber
    jsr PrintS

    ldy # VRAM + XOffset + 10 + VramWidth*17
    ldx #Str.Exit
    jsr PrintS

    ldy # VRAM + XOffset + 5 + VramWidth*20
    ldx #Str.Push
    jsr PrintS
rts
